package com.sergiofrutos.kduino_v2;




import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import java.io.IOException;


/**
 * Definimos las acciones en función de la opción escogida por el usuario en el menu control y lanzamos el dialogo de espera
 */
public class Asynctaskfunction extends AsyncTask<Void,Void,Void> {

    //creamos las variables
    private ProgressDialog dialog;
    private  BluetoothUtilities bluetoothutilities;
    private String datareceived;
    private  Activity activity;
    private Fileutilities fileutilities;
    private  Menu_control.ActivityType activityType;
    private String data;
    private int i=0;
    private final char endata='+';
    StringBuilder sbdata=new StringBuilder();

    public Asynctaskfunction(Activity activity,BluetoothUtilities bluetoothUtilities, Fileutilities fileutilities,Menu_control.ActivityType activityType) {
        super();
        this.bluetoothutilities=bluetoothUtilities;
        this.activityType=activityType;
        this.activity=activity;
        this.fileutilities=fileutilities;
        dialog = new ProgressDialog(this.activity);
        dialog.setMessage("Wait!");
        dialog.setCanceledOnTouchOutside(false);
        dialog.setCancelable(false);
    }

    @Override
    protected Void doInBackground(Void... params) {




                        try {
                            datareceived = bluetoothutilities.read_data();


                        } catch (IOException e6) {
                            // TODO Auto-generated catch block
                            e6.printStackTrace();
                        }





        return null;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();

        dialog.show();
    }

    @Override
    protected void onPostExecute(Void aVoid) {
        super.onPostExecute(aVoid);


        switch (activityType) {

            case SETTIME:

                if (datareceived!=null && datareceived.indexOf("+")!=-1){

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Time has been saved in Kduino");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Can't save time in Kduino" );

                }

                break;


            case START:

                if (datareceived!=null && datareceived.indexOf("+")!=-1){

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Kduino is starting");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), " Kduino can't start" );

                }

                break;

            case STOP:

                if (datareceived!=null && datareceived.indexOf("+")!=-1){

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Kduino has stopped");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), " Kduino can't stop" );

                }

                break;

            case GETDATA:

                if (fileutilities != null) {

                    //Lo grabamos en dos txt, uno para trabajar con el y el que nos piden de backup
                    fileutilities.insertardatatofile(datareceived, "dades_boia");
                    fileutilities.insertardatatobackup(datareceived, "dades_backup");

                }


                if (datareceived!=null && datareceived.indexOf("+")!=-1){

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Data has been read");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Can't read data" );

                }

                break;

            case DELETEDATA:

                if ((datareceived!=null && datareceived.indexOf("+")!=-1)){

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content),"Data has been deleted");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Can't delete data");
                }



                break;

            case CALIBRATION:


                if (fileutilities != null) {

                    //Lo grabamos en dos txt, uno para trabajar con el y el que nos piden de backup
                    fileutilities.insertardatatofile(datareceived, "cal_boia");
                    fileutilities.insertardatatobackup(datareceived, "dades_backup");

                }


                if (datareceived!=null && datareceived.indexOf("+")!=-1){

                    //Imprimimos solo los datos sin el ack="+"
                    while ((char)datareceived.charAt(i) != endata){

                        sbdata.append(String.valueOf(datareceived.charAt(i)));
                        i=i+1;


                    }

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Kduino has been calibrated");
                }else{

                    General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Kduino has not been calibrated");
                }

                    break;

                    case READTIME:

                        if (datareceived!=null && datareceived.indexOf("+")!=-1){

                            //Por si queremos imprimir solo los datos sin el ack="+"
                            while ((char)datareceived.charAt(i) != endata){

                                sbdata.append(String.valueOf(datareceived.charAt(i)));
                                i=i+1;


                            }

                            General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Time has been read");
                        }else{

                            General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Time can't be read" );

                        }


                        break;

                    case TESTSENSORS:

                        if (datareceived!=null && datareceived.indexOf("+")!=-1){

                            Intent intent2 = new Intent();
                            intent2.setClass(this.activity, Test_results.class);
                            intent2.putExtra("datareceived", datareceived);
                            this.activity.startActivity(intent2);

                        }else{

                            General_utilities.dialogo(this.activity.findViewById(android.R.id.content), "Sensors can't be tested" );

                        }

                        break;



        }

        //lo dejamos para comprobar cuando sea necesario lo que se recibe de la boia
        //General_utilities.dialogo(this.activity.findViewById(android.R.id.content), datareceived);

        dialog.dismiss();
    }

    @Override
    protected void onProgressUpdate(Void... values) {
        super.onProgressUpdate(values);
    }


}
