package com.sergiofrutos.kduino_v2;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.UUID;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Build;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;


/**
 * Utilidades para la conexión  Bluetooth
 */
public class Connect_bluetooth extends Activity{
	
	
	//creamos las variables
	private static final int REQUEST_ENABLE_BT = 1;
	  
	private Button onBtn;

    private Button offBtn;

    private Button findBtn;
    
    private Button cancelBtn;
    
    private TextView text;

    private  static BluetoothAdapter myBluetoothAdapter;

    private ListView myListView;

    private ArrayAdapter<String> BTArrayAdapter;
   
    private ArrayList dispositivos = new ArrayList();
    
    protected static BluetoothSocket btSocket = null;
    
    protected static OutputStream outStream = null;
    
    protected static InputStream inputStream= null;

    private int posicio_llista;

    private View view;

    // SPP UUID service 
    private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

    // MAC-address
    protected String addressboia;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.connect);

        //inicializamos la dirección MAC a nul
        addressboia=null;

		//relacionamos los botones con los del layout
		onBtn = (Button) findViewById(R.id.bt_on);
		offBtn = (Button) findViewById(R.id.bt_off);
		findBtn = (Button) findViewById(R.id.bt_find);
		cancelBtn = (Button) findViewById(R.id.bt_cancel);
		
		//limpiamos la lista de dispositivos
		dispositivos.clear();
		
		//obtenemos la conexión al bluetooth
		myBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        //obtenemos la vista del layaout
        view=findViewById(android.R.id.content);


        //si presionamos el boton cancel, volvemos al menu anterior, cerramos el Socket si está abierto y acabamos la actividad
		cancelBtn.setOnClickListener(new OnClickListener() {

		      @Override
		      public void onClick(View arg0) {

                      Intent intent = new Intent();
                      intent.setClass(Connect_bluetooth.this, MainActivity.class);
                      startActivity(intent);

		         
		      }
		    });
		
		//si el dispositivo no dispone de bluetooth
		if(myBluetoothAdapter == null) {
			
		    //muestro por pantalla que no se soporta bluetooth
            General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Bluetooth: not supported");

		    
		} else {

			//relacionamos el textview con su objeto
		    text = (TextView) findViewById(R.id.status);

            //miramos si esta conectado previamente y mostramos el status
            comprobarestado();

		    
		    //creo un objeto boton para cada boton y le indico que metodo a de iniciar en cada caso
		    onBtn.setOnClickListener(new OnClickListener() {

		      @Override
		      public void onClick(View v) {
		          // TODO Auto-generated method stub
		          on(v);
		          
		      }
		    });

		   
		    offBtn.setOnClickListener(new OnClickListener() {

		      @Override
		      public void onClick(View v) {
		          // TODO Auto-generated method stub
		    	  
		          off(v);
		         
		      }
		    });
		    
		    
		    findBtn.setOnClickListener(new OnClickListener() {
		  
		      @Override
		      public void onClick(View v) {
		 
		     // TODO Auto-generated method stub
		      find(v);
		 
		       }

		      });
		    
		  //relacionamos el textview con su objeto
		    myListView = (ListView)findViewById(R.id.listdevices);
		    
		    //hacemos que solo se pueda seleccionar un elemento de la lista
		    myListView.setChoiceMode(ListView.CHOICE_MODE_SINGLE);

		    //creamos un ArrayAdapter que contendrá los devices encontrados y los metera en la lista
		    BTArrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
		    myListView.setAdapter(BTArrayAdapter);
		    
		    //al selecionar un elemento de la lista
		    myListView.setOnItemClickListener(new OnItemClickListener() {
		    	  @Override
		    	  public void onItemClick(AdapterView<?> parent, View view,
		    	    int position, long id) {
		    		  

                        //obtenemos la MAC del dispositivo seleccionado en la lista
		    		  	posicio_llista=position;
		    		  	BluetoothDevice dispositivo = (BluetoothDevice) dispositivos.get(posicio_llista);
		    			addressboia=dispositivo.getAddress();
                        //checkeamos la conexión sobre esa MAC
		    			checkstate(addressboia);
		    		  
		    	  }
		    	}); 

			}
		
		}
		  	
		//se activa el bluetooth
		public void on(View view){
				
		        if (!myBluetoothAdapter.isEnabled()) {

		           Intent turnOnIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);

		           startActivityForResult(turnOnIntent, REQUEST_ENABLE_BT);


		        }

		     }

        //dependiendo de si se puede activar el bluetooth o no, lo indicamos en pantalla
		@Override
		protected void onActivityResult(int requestCode, int resultCode, Intent data) {

		     // TODO Auto-generated method stub

		     if(requestCode == REQUEST_ENABLE_BT){

		         if(myBluetoothAdapter.isEnabled()) {

		             text.setText("Status: Enabled");

		         } else {  

		             text.setText("Status: Disabled");

		         }

		     }

		 }

        //listamos los dispositivos encontrados
		public void list(View view){

	        //lo ponemos en el adapter
	        BluetoothDevice device2 = null;

				for(BluetoothDevice device :  myBluetoothAdapter.getBondedDevices())
				
                    //guardamos los dispositivos para recuperar la MAC después
					device2=device;
				    BTArrayAdapter.add(device2.getName()+ "\n"+device2.getAddress() );
	       
			
	     }

        //cuando encontramos un dispositivo
		final BroadcastReceiver bReceiver = new BroadcastReceiver() {

        //cuando encontramos un dispositivos
		public void onReceive(Context context, Intent intent) {
			
		   String action = intent.getAction();


		   if (BluetoothDevice.ACTION_FOUND.equals(action)) {
			   

		        //obtenemos el objeto BluetoothDevice del intent
		        BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
               //añadimos a una lista los dispositivos para después relacionarlos con el escogido de la lista mediante la posición
		        dispositivos.add(device);
		       //añadimos el nombre y la MAC del objeto al arrayAdapter
		        BTArrayAdapter.add(device.getName() + "\n" + device.getAddress());
		        BTArrayAdapter.notifyDataSetChanged();


		        
		   }

		}

		};	

        //buscamos los dispositivos
		public void find(View view) {

		      if (myBluetoothAdapter.isDiscovering()) {

		          // si estaba buscando paramos la búsqueda
		          myBluetoothAdapter.cancelDiscovery();

		      }

		      else {
		    	  
		    	  //limpiamos el adaptador y empezamos a buscar dispositivos
		           BTArrayAdapter.clear();
		           myBluetoothAdapter.startDiscovery();
		           registerReceiver(bReceiver, new IntentFilter(BluetoothDevice.ACTION_FOUND));   

		       }   

		  }

        //desconecta el bluetooth
		public void off(View view){

		     myBluetoothAdapter.disable();
             onBtn.setEnabled(true);

		     text.setText("Status: Disconnected");


		  }

		  @Override
		protected void onDestroy() {

		         super.onDestroy();

		         unregisterReceiver(bReceiver);

		     }

        //comprovamos si está activo el bluetooth si está activo procede a conectarse si no avisa al usuario
		 public void checkstate(String addressboia) {
			 
			 myBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
			    
			    if(myBluetoothAdapter==null) {

                    General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Bluetooth: not supported");

			      
			    } else {
			      if (myBluetoothAdapter.isEnabled()) {
			    	 
			    	  //si esta activat el bluetooth ens connectem
			    	  connexio(addressboia);
			    	  
			      } else {
			        //si no podem conectarnos lo demanen a l'usuari que el connecti

                      General_utilities.Mostrarmensajecorto(getApplicationContext(),view,"Can't connect to Bluettoth");
                      General_utilities.dialogo(view,"Turn on your Bluetooth,please");

			      }
			    }
			  }

		//método per conectarse al Kduino
		 public void connexio(String addressboia2) {

             BluetoothDevice device = myBluetoothAdapter.getRemoteDevice(addressboia2);

             try {
                 btSocket = createBluetoothSocket(device);

             } catch (IOException e1) {

                 e1.printStackTrace();

                 General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Fatal Error,In onResume() and socket create failed,TRY TO CONNECT AGAIN!");

             }


             //cancelamos la búsqueda
             myBluetoothAdapter.cancelDiscovery();


             //establecemos la conexión
             try {

                 btSocket.connect();


             } catch (IOException e2) {
                 try {

                     e2.printStackTrace();
                     General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Fatal Error,In onResume() and socket create failed, TRY AGAIN!");
                     btSocket.close();

                 } catch (IOException e3) {

                     e3.printStackTrace();
                     General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Fatal Error,In onResume() and unable to close socket during connection failure");

                 }

             }
                 //una vez creada la conexión creamos un outStrem i inputStream para operar con el posteriormente
             try {
                     outStream = btSocket.getOutputStream();
                     inputStream = btSocket.getInputStream();

                 } catch (IOException e4) {

                    e4.printStackTrace();
                    General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Fatal Error,In onResume() and output/input stream creation failed");
                 }

                    //una vez conectados vamos al menu control
                    if (btSocket.isConnected()) {

                        Intent intent2 = new Intent();
                        intent2.setClass(Connect_bluetooth.this, Menu_control.class);
                        startActivity(intent2);

                    }

         }
			 
		//creamos el socket para conectarnos
		public BluetoothSocket createBluetoothSocket(BluetoothDevice device) throws IOException {
		      if(Build.VERSION.SDK_INT >= 10){
		          try {
		              final Method  m = device.getClass().getMethod("createInsecureRfcommSocketToServiceRecord", new Class[] { UUID.class });
		              return (BluetoothSocket) m.invoke(device, MY_UUID);
		          } catch (Exception e5) {

                      e5.printStackTrace();
                      General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Could not create Insecure RFComm Connection");
		          }
		      }
		      return  device.createRfcommSocketToServiceRecord(MY_UUID);
		  }

        //miramos si esta conectado el bluettoth
        private void comprobarestado(){

            if(myBluetoothAdapter.isEnabled()) {

                text.setText("Status: Enabled");
                onBtn.setEnabled(false);

            } else {

                text.setText("Status: Disabled");

            }

    }

		
	}
	
	


