package com.sergiofrutos.kduino_v2;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import android.app.Activity;
import android.content.Context;
import android.os.Environment;
import android.view.View;


/**
 * Utilidades generales, sobre los archivos txt
 */
public class Fileutilities extends Activity{

    //creamos las variables
    private final static String NOMBREARCHIVOPROFILE="dades_usuari";
    private Context mcontext;
    private View view;



    public Fileutilities(Context context,View view){

        mcontext=context;
        this.view=view;
    }

    //crea el txt del profile
    public  void crearArchivoprofile (Profile profile) {


        try {
            File data_user = Environment.getExternalStorageDirectory();
            File file = new File(data_user.getAbsolutePath(), NOMBREARCHIVOPROFILE);
            OutputStreamWriter osw = new OutputStreamWriter(mcontext.openFileOutput(NOMBREARCHIVOPROFILE, Context.MODE_PRIVATE));
            osw.write(profile.toString());
            osw.flush();
            osw.close();

            General_utilities.Mostrarmensajecorto(mcontext,view,"Profile saved");


        } catch (IOException e) {

            e.printStackTrace();
            General_utilities.Mostrarmensajelargo(mcontext,view,"Profile can't be saved");


        }
    }

    //inserta los datos en el archivo txt de trabajo
    public void insertardatatofile (String data,String name) {


        try {
            File data_user = Environment.getExternalStorageDirectory();
            File file = new File(data_user.getAbsolutePath(), name);
            OutputStreamWriter osw = new OutputStreamWriter(mcontext.openFileOutput(name, Context.MODE_PRIVATE));
            osw.write(data);
            osw.flush();
            osw.close();

            General_utilities.Mostrarmensajecorto(mcontext,view,"Data saved");

        } catch (IOException e1) {

            e1.printStackTrace();

            General_utilities.Mostrarmensajelargo(mcontext,view,"Data can't be saved");


        }
    }

    //inserta los datos en el archivo txt de backup
    public void insertardatatobackup (String data,String name){

        try {
            File data_user = Environment.getExternalStorageDirectory();
            File file = new File(data_user.getAbsolutePath(), name);
            OutputStreamWriter osw = new OutputStreamWriter(mcontext.openFileOutput(name, Context.MODE_APPEND));
            osw.write(data);
            osw.flush();
            osw.close();


        } catch (IOException e2) {

            e2.printStackTrace();


        }


    }

    //recupera los datos del archivo txt con el profile
    public Profile recuperarprofile() {

            Profile profilerecupered = new Profile();
            InputStreamReader fis = null;
            BufferedReader br = null;


            try {
                //creamos un objeto InputStreamReader, que será el que nos permita leer el contenido del archivo de texto
                fis = new InputStreamReader(mcontext.openFileInput(NOMBREARCHIVOPROFILE));
                //creamos un objeto buffer, en el que iremos almacenando el contenido del archivo
                br = new BufferedReader(fis);


                //por cada EditText leemos una línea y escribimos el contenido en el
                profilerecupered.setKduinoname(br.readLine());

                profilerecupered.setNumberofsensor(Integer.valueOf(br.readLine()));

                profilerecupered.setDepth_1(br.readLine());

                profilerecupered.setDepth_2(br.readLine());

                profilerecupered.setDepth_3(br.readLine());

                profilerecupered.setDepth_4(br.readLine());

                profilerecupered.setDepth_5(br.readLine());

                profilerecupered.setDepth_6(br.readLine());

                profilerecupered.setLat(br.readLine());

                profilerecupered.setLongi(br.readLine());

                profilerecupered.setMarkername(br.readLine());

                profilerecupered.setDate(br.readLine());

                profilerecupered.setTime(br.readLine());

                //cerramos el flujo de lectura del archivo.
                br.close();
                fis.close();


                return profilerecupered;

            } catch (Exception e3) {

                e3.printStackTrace();
                General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Profile can't be recupered");
                return null;

            }
        }

    //recupera los datos del archivo txt con los datos que ha enviado el kduino
    public String recuperardata(String nameoffile){

        InputStreamReader fis2 = null;
        BufferedReader br2=null;
        final String data;
        int i=0;
        final char endata='+';
        StringBuilder sbdata=new StringBuilder();

        try {
            // Creamos un objeto InputStreamReader, que será el que nos permita
            // leer el contenido del archivo de texto.

            fis2 = new InputStreamReader(mcontext.openFileInput(nameoffile));
            // Creamos un objeto buffer, en el que iremos almacenando el contenido
            // del archivo.
            br2 = new BufferedReader(fis2);

            //leemos la información
            data=br2.readLine();

            // Cerramos el flujo de lectura del archivo.
            br2.close();
            fis2.close();

            //Mandamos solo los datos sin el ack="+"
            while ((char)data.charAt(i) != endata){

                sbdata.append(String.valueOf(data.charAt(i)));
                i=i+1;


            }

            return sbdata.toString();

        } catch (Exception e4) {
            General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"Data can't be recupered");
            e4.printStackTrace();
            return null;

        }
    }

	
		 
}
        