package com.sergiofrutos.kduino_v2;




import java.io.File;
import android.app.Activity;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.support.v4.app.NotificationCompat;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

/**
 * Menú principal que muestra menu con opciones
 */
public class MainActivity extends Activity {
	

	private String dates=null;
    private String calibrations=null;
    private View view;
    private static final int NOTIFICATION_ID = 1;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);


        //obtenemos la vista del layaout
        view=findViewById(android.R.id.content);

        //creamos los objetos  para acceder a sus métodos
        Fileutilities fileutilities=new Fileutilities(getApplicationContext(),view);



        //abrimos los archivos de texto
		File dir = getFilesDir();
		File file=new File(dir, "dades_usuari");
        File dir2 = getFilesDir();
        File file2=new File(dir2, "dades_boia");
        File dir3 = getFilesDir();
        File file3=new File(dir3, "cal_boia");


        // Asignamos los objetos a los elementos del layout
		final Button btnMakeaKduino = (Button)this.findViewById(R.id.bt_makeakaduino);
		final Button btnControl=(Button) this.findViewById(R.id.bt_control);
		final Button btnInfo = (Button)this.findViewById(R.id.bt_info);
		final Button btnExit = (Button)this.findViewById(R.id.bt_exitmain);


		//comprovamos si hay conexión y si existen los archivos con las medidas
			ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
			NetworkInfo netInfo = cm.getActiveNetworkInfo();

        if ((file3.exists()|| file2.exists()) && file.exists() && netInfo != null && netInfo.isConnected()){



            if (file2.exists()) {

                dates=fileutilities.recuperardata("dades_boia");

            }
            if (file3.exists()) {

                calibrations = fileutilities.recuperardata("cal_boia");
            }

            Profile profile = fileutilities.recuperarprofile();

            try {

                Thread t = new Thread(new InseriraDB(getApplicationContext(), profile.getKduinoname(), String.valueOf(profile.getNumberofsensor()), profile.getDepth_1(), profile.getDepth_2(), profile.getDepth_3(), profile.getDepth_4(), profile.getDepth_5(), profile.getDepth_6(), profile.getLat(), profile.getLongi(), profile.getMarkername(), dates, calibrations, profile.getDate(), profile.getTime()));
                t.start();

                General_utilities.Mostrarmensajecorto(getApplicationContext(),view,"Data and profile have been saved");

            }catch (Exception e0){

                e0.printStackTrace();
                General_utilities.Mostrarmensajecorto(getApplicationContext(),view,"Data and profile haven't been saved");

            }


            if (file.delete() && (file2.delete() || file3.delete())) {

                General_utilities.Mostrarmensajecorto(getApplicationContext(),view,"Data deleted");
                NotificationManager notifManager= (NotificationManager) getApplicationContext().getSystemService(Context.NOTIFICATION_SERVICE);
                notifManager.cancelAll();


            } else {

                General_utilities.Mostrarmensajecorto(getApplicationContext(), view, "Data can't be deleted");

            }

        }else if(file.exists() || file2.exists() || file3.exists() ){

            sendNotification(view,"There is data to send.Connect to Internet.");

        }


        //en clickar el botón lanzamos el layout correspondiente
		btnMakeaKduino.setOnClickListener(new OnClickListener(){ 
			public void onClick(View arg0) {
				
				//lanzamos el Menu_makeaKduino
				Intent intent = new Intent(); 
				intent.setClass(MainActivity.this, Menu_makeaKduino.class);
				startActivity(intent);

				
			}
		});
			
		
		btnControl.setOnClickListener(new OnClickListener(){
			public void onClick(View arg0) {
				
				//lanzamos el control_menu
				Intent intent = new Intent(); 
				intent.setClass(MainActivity.this, Connect_bluetooth.class);
                startActivity(intent);
				
				
			}
		});
			
		
		btnInfo.setOnClickListener(new OnClickListener(){ 
			public void onClick(View arg0) {
				
				//lanzamos la información
				Intent intent = new Intent(); 
				intent.setClass(MainActivity.this, Informacio.class);
				startActivity(intent);
				
				
			}
		});
		
		btnExit.setOnClickListener(new OnClickListener(){ 
			public void onClick(View arg0) {

                //finalizamos la aplicación
                Intent intent= new Intent(Intent.ACTION_MAIN);
                intent.addCategory(Intent.CATEGORY_HOME);
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);

			}
		});
					
	
	
    }

    /**
     * Lanzamos la notificación si existen datos para enviar
     */
    public void sendNotification(View view,String message) {


            //utilizamos un NotificationCompat.Builder para configurar nuestra notificación
            NotificationCompat.Builder builder = new NotificationCompat.Builder(this);

            //añadimos el icono que aparecerá en la notificación
            builder.setSmallIcon(R.drawable.citclopslogo);

            //añadimos la funcionalidad que tendrá cuando la clicken, accederá a la pantalla main.
            Intent resultIntent = new Intent(this, MainActivity.class);
            PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, resultIntent, 0);
            builder.setContentIntent(pendingIntent);

            //añadimos el texto a mostrar
            builder.setTicker("Kduino Notification");

            //le añadimos funcionalidades de vibración
            builder.setVibrate(new long[]{100, 800});

            //añadimos el mensaje a mostrar
            builder.setContentText(message);

            //lanzamos la notifiación en la barra
            NotificationManager notificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
            notificationManager.notify(NOTIFICATION_ID, builder.build());



    }


}
	
