package com.sergiofrutos.kduino_v2;





import java.io.IOException;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

/**
 * Menú que proporciona las funcionalidades sobre el Kduino
 */
public class Menu_control extends Activity {



    private String date;
    private String time;
    private View view;
    public enum ActivityType {SETTIME, START, STOP, GETDATA, DELETEDATA, CALIBRATION, READTIME,TESTSENSORS}


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        // TODO Auto-generated method stub
        super.onCreate(savedInstanceState);
        setContentView(R.layout.control_menu);


        //obtenemos la vista del layaout
        view = findViewById(android.R.id.content);


        // Asignamos los objetos a los elementos del layout
        final Button btngetdata = (Button) this.findViewById(R.id.bt_get_data);
        final Button btndeletedata = (Button) this.findViewById(R.id.bt_delete_data);
        final Button btnstartmeasures = (Button) this.findViewById(R.id.bt_start);
        final Button btnstopmeasures = (Button) this.findViewById(R.id.bt_stop);
        final Button btnsettime = (Button) this.findViewById(R.id.bt_set_time);
        final Button btncalibration = (Button) this.findViewById(R.id.bt_calibration);
        final Button btnreadtime = (Button) this.findViewById(R.id.bt_read_time);
        final Button btntestsensors = (Button) this.findViewById(R.id.bt_test_sensors);
        final Button btnexit = (Button) this.findViewById(R.id.bt_return);
        final BluetoothUtilities bluetoothutilities = new BluetoothUtilities(getApplicationContext(),view);
        final Fileutilities fileutilities = new Fileutilities(getApplicationContext(),view);




        //si seleccionamos el boton getdada, mandamos una D y esperamos recibir una serie de datos con ACK
        btngetdata.setOnClickListener(new OnClickListener() {
            public void onClick(View arg0) {

                bluetoothutilities.sendData("D");

                new Asynctaskfunction(Menu_control.this,bluetoothutilities,fileutilities,ActivityType.GETDATA).execute();


            }


        });

        //si seleccionamos el boton delete data, mandamos una Z y recibimos un ACK del kduino cuando ha borrado toda la información
        btndeletedata.setOnClickListener(new OnClickListener() {
            public void onClick(View arg0) {


             bluetoothutilities.sendData("Z");


                new Asynctaskfunction(Menu_control.this,bluetoothutilities,fileutilities,ActivityType.DELETEDATA).execute();




            }
        });

        //si seleccionamos el boton start measures,mandamos una S y recibimos un ACK del kduino si ha empezado
        btnstartmeasures.setOnClickListener(new OnClickListener() {
            public void onClick(View arg0) {

                bluetoothutilities.sendData("S");


                new Asynctaskfunction(Menu_control.this,bluetoothutilities,fileutilities,ActivityType.START).execute();

            }
        });

        //si seleccionamos el boton stop measures, mandamos una U  recibimos un ACK del kduino cuando este se este parado
        btnstopmeasures.setOnClickListener(new OnClickListener() {
            public void onClick(View arg0) {


                bluetoothutilities.sendData("U");


                new Asynctaskfunction(Menu_control.this,bluetoothutilities,fileutilities,ActivityType.STOP).execute();


            }
        });

        //si seleccionamos el boton set time, mandamos una T y posteriorment enviamos la fecha y hora al kduino y esperamos el ACK
        btnsettime.setOnClickListener(new OnClickListener() {
            public void onClick(View arg0) {


                bluetoothutilities.sendData("T");




                        //obtenemos la fecha y la hora y la enviamos caracter a caracter
                        date = TimeandDate.getDate();
                        time = TimeandDate.getTime();


                        StringBuilder sbdatatosendt = new StringBuilder();

                        sbdatatosendt.append(date + time);


                        int i = 0;

                        while (i < sbdatatosendt.length()) {


                            bluetoothutilities.sendData(String.valueOf(sbdatatosendt.charAt(i)));


                            i = i + 1;
                        }


                new Asynctaskfunction(Menu_control.this,bluetoothutilities,fileutilities,ActivityType.SETTIME).execute();


                    }

                });
                //si seleccionamos el boton calibration, mandamos una C y recibimos una serie de información con la calibración de los sensores y esperamos el ACK
                btncalibration.setOnClickListener(new OnClickListener() {
                    public void onClick(View arg0) {


                       bluetoothutilities.sendData("C");


                        new Asynctaskfunction(Menu_control.this, bluetoothutilities, fileutilities, ActivityType.CALIBRATION).execute();


                    }
                });

                //si seleccionamos el boton read time, mandamos una R y recibimos la hora y la fecha del kduino con ACK
                btnreadtime.setOnClickListener(new OnClickListener() {
                    public void onClick(View arg0) {


                        bluetoothutilities.sendData("R");

                        new Asynctaskfunction(Menu_control.this, bluetoothutilities, fileutilities, ActivityType.READTIME).execute();



                    }
                });

                //si seleccionamos el boton test sensors, mandamos una Q y obtenemos los datos y los mostramos en la pantallatest_results
                btntestsensors.setOnClickListener(new OnClickListener() {
                    public void onClick(View arg0) {


                        bluetoothutilities.sendData("Q");
                        new Asynctaskfunction(Menu_control.this, bluetoothutilities, fileutilities, ActivityType.TESTSENSORS).execute();



                    }
                });

                //si seleccionamos el boton exit, cerramos las conexiones y volvemos a la pantalla principal
                btnexit.setOnClickListener(new OnClickListener() {
                    public void onClick(View arg0) {


                        try {

                            // Connect_bluetooth.aReader.close();
                            Connect_bluetooth.inputStream.close();
                            Connect_bluetooth.outStream.close();
                            Connect_bluetooth.btSocket.close();

                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        //Lanzamos el control_menu
                        Intent intent = new Intent();
                        intent.setClass(Menu_control.this, MainActivity.class);
                        finish();
                        startActivity(intent);


                    }
                });


            }

    }








       

