package com.sergiofrutos.kduino_v2;





import android.location.LocationManager;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;

/**
 * Menú con los datos que ha de ingresar el usuario
 */
public class Menu_makeaKduino extends Activity {
	

	private Spinner lista;
	private String [] datos_spinner = {"Select the number of sensors:","3","4","5","6"};
	protected double depth_1=0.0;
	protected double depth_2=0.0;
	protected double depth_3=0.0;
	protected double depth_4=0.0;
	protected double depth_5=0.0;
	protected double depth_6=0.0;
	private int numberofsensor=0;
	private String time;
    private String date;
	private CheckBox cbRecordar;
	private Button btnsave;
	private Button btncancel;
	private EditText Editname;
	private EditText Editnameofkaduino;
	private EditText Editlocationrecupered;
	private EditText Edittimerecupered;
    private Profile profile=new Profile();
    protected View view;
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.makeakduino_menu);

        //obtenemos la vista del layaout
        view=findViewById(android.R.id.content);

        //creamos un objeto del tipo Fileutilities
        final Fileutilities fileutilities=new Fileutilities(getApplicationContext(),view);

		//leemos la hora y la fecha
	    time = TimeandDate.getTime();
        date=TimeandDate.getDate();


		
		// asignamos los objetos a los elementos del layout
		Editname = (EditText) findViewById(R.id.et_marker);
		Editnameofkaduino = (EditText) findViewById(R.id.et_nameofkaduino);
		Editlocationrecupered = (EditText) findViewById(R.id.et_locationnumber);
		Edittimerecupered = (EditText) findViewById(R.id.et_timenumber);
		cbRecordar = (CheckBox) findViewById(R.id.cb_inserted);
		btnsave = (Button)this.findViewById(R.id.btn_save);
		btncancel = (Button)this.findViewById(R.id.btn_cancel);
		
		// mostramos el time y la date en su campo
		Edittimerecupered.setText(date +" "+ time);


        /**
        * Lanzamos el GPSActivity como un hilo para obtener los datos GPS
        */
		this.runOnUiThread(new Runnable() {

			@Override
			public void run() {
				// TODO Auto-generated method stub
				
				
				LocationManager mLocationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
				
				LocationListener mLocationListener = new MyLocationLIstener();

				mLocationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 1000, mLocationListener);
				
				
			}
			
			class MyLocationLIstener implements LocationListener{

				
				@Override
				public void onLocationChanged(Location location) {
					// TODO Auto-generated method stub
					//Obtenemos la latitud y la longitud y lo insertamos en el campo correspondiente
                    profile.setLat(String.valueOf(location.getLatitude()));
                    profile.setLongi(String.valueOf(location.getLongitude()));
                    Editlocationrecupered.setText(profile.getLat()+" "+profile.getLongi());
					
				}

				@Override
				public void onStatusChanged(String provider, int status,
						Bundle extras) {
					// TODO Auto-generated method stub

				}

				@Override
				public void onProviderEnabled(String provider) {
					// TODO Auto-generated method stub


				}

				@Override
				public void onProviderDisabled(String provider) {
					// TODO Auto-generated method stub
					General_utilities.Mostrarmensajelargo(getApplicationContext(),view,"No network provided ");
				}
				
				
			}
	
		});



         //al pulsar cancel acabamos y volvemos al menu principal
		btncancel.setOnClickListener(new OnClickListener(){
					public void onClick(View arg0)  {

		    //Lanzamos el MainActivity
			Intent intent6 = new Intent();
			intent6.setClass(Menu_makeaKduino.this, MainActivity.class);
            finish();
			startActivity(intent6);


		 }
		});


        //al pulsar el botón save grabamos los datos en un txt
		btnsave.setOnClickListener(new OnClickListener(){
					public void onClick(View arg0) {

						
            profile.setMarkername(Editname.getText().toString());

            profile.setKduinoname(Editnameofkaduino.getText().toString());

			profile.setTime(time);

            profile.setDate(date);


             //no dejamos grabar el archivo y volver a la pantalla main si no se han llenado todos los campos o se cancela
             if(profile.getMarkername().isEmpty() || profile.getKduinoname().isEmpty() || numberofsensor==0 ) {

                  General_utilities.dialogo(view,"Fill all gaps, please!");

             }else{

                  fileutilities.crearArchivoprofile(profile);


                  //volvemos a la pantalla inicial
                   Intent intent7 = new Intent();
                   intent7.setClass(Menu_makeaKduino.this, MainActivity.class);
                   startActivity(intent7);
                   finish();

             }
							 
		}

		});

				
		/**
		* Spinner mètode
		*/
					
		//instanciamos el spinner y creamos un array adapter(vista en la que se muestra objeto que lo muestra datos)
		lista = (Spinner) findViewById(R.id.sp_numberofsensors);
		ArrayAdapter<String> adapter=new ArrayAdapter<String> (this,android.R.layout.simple_spinner_item,datos_spinner);

		//vinculamos la lista con el adaptador
		lista.setAdapter(adapter);
			
		//al selecionar un elemento de la lista obtenemos lanzamos el menu de profundidades correspondiente
		lista.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

					@Override
					public void onItemSelected(AdapterView<?> parent,
							View viewer, int position, long id) {
						
						// TODO Auto-generated method stub
						
						switch(position){
						
						case (1):
							
							//lanza pantalla con 3 edittext a rellenar
							Intent intent = new Intent(); 
							intent.setClass(Menu_makeaKduino.this, Menu_depthfor3sensors.class);
                            startActivityForResult(intent, 1);
								
							break;
						
						case (2):
						
							//lanza pantalla con 4 edittext a rellenar
							Intent intent2 = new Intent(); 
							intent2.setClass(Menu_makeaKduino.this, Menu_depthfor4sensors.class);
                            startActivityForResult(intent2, 2);

							break;
						
						case (3):

							//lanza pantalla con 5 edittext a rellenar
							Intent intent3 = new Intent(); 
							intent3.setClass(Menu_makeaKduino.this, Menu_depthfor5sensors.class);
                            startActivityForResult(intent3, 3);

							break;
						
						case (4):
							
							//lanza pantalla con 6 edittext a rellenar
							Intent intent4 = new Intent(); 
							intent4.setClass(Menu_makeaKduino.this, Menu_depthfor6sensors.class);
                            startActivityForResult(intent4, 4);

							break;
						}
					}
						
						@Override
						public void onNothingSelected(AdapterView<?> parent) {
							// TODO Auto-generated method stub
							
						}

		});
	}

	/**
	* Definimos las acciones despues de volver del menu de la profundidad de los sensores
	*/
	protected void onActivityResult (int requestCode, int resultCode, Intent datos) {

		if (requestCode == 1) {

			if (resultCode == RESULT_OK) {
				
				
				this.depth_1=datos.getDoubleExtra("depth1", 0);
				profile.setDepth_1(String.valueOf(this.depth_1));
                this.depth_2=datos.getDoubleExtra("depth2", 0);
				profile.setDepth_2(String.valueOf(this.depth_2));
                this.depth_3=datos.getDoubleExtra("depth3", 0);
				profile.setDepth_3(String.valueOf(this.depth_3));
                profile.setDepth_4(String.valueOf(this.depth_4));
                profile.setDepth_5(String.valueOf(this.depth_5));
                profile.setDepth_6(String.valueOf(this.depth_6));

				cbRecordar.setChecked(true);
				cbRecordar.setEnabled(false);
				this.numberofsensor=3;
                profile.setNumberofsensor(this.numberofsensor);

			}
		}
		if (requestCode == 2) {

			if (resultCode == RESULT_OK) {

				
				this.depth_1=datos.getDoubleExtra("depth1", 0);
                profile.setDepth_1(String.valueOf(this.depth_1));
				this.depth_2=datos.getDoubleExtra("depth2", 0);
                profile.setDepth_2(String.valueOf(this.depth_2));
				this.depth_3=datos.getDoubleExtra("depth3", 0);
                profile.setDepth_3(String.valueOf(this.depth_3));
				this.depth_4=datos.getDoubleExtra("depth4", 0);
                profile.setDepth_4(String.valueOf(this.depth_4));
                profile.setDepth_5(String.valueOf(this.depth_5));
                profile.setDepth_6(String.valueOf(this.depth_6));

				cbRecordar.setChecked(true);
				cbRecordar.setEnabled(false);
				this.numberofsensor=4;
                profile.setNumberofsensor(this.numberofsensor);

			}
		}
		if (requestCode == 3) {

			if (resultCode == RESULT_OK) {

				this.depth_1=datos.getDoubleExtra("depth1", 0);
                profile.setDepth_1(String.valueOf(this.depth_1));
				this.depth_2=datos.getDoubleExtra("depth2", 0);
                profile.setDepth_2(String.valueOf(this.depth_2));
				this.depth_3=datos.getDoubleExtra("depth3", 0);
                profile.setDepth_3(String.valueOf(this.depth_3));
				this.depth_4=datos.getDoubleExtra("depth4", 0);
                profile.setDepth_4(String.valueOf(this.depth_4));
				this.depth_5=datos.getDoubleExtra("depth5", 0);
                profile.setDepth_5(String.valueOf(this.depth_5));
                profile.setDepth_6(String.valueOf(this.depth_6));
				
				cbRecordar.setChecked(true);
				cbRecordar.setEnabled(false);
				this.numberofsensor=5;
                profile.setNumberofsensor(this.numberofsensor);

			}
		}
		if (requestCode == 4) {

			if (resultCode == RESULT_OK) {

				this.depth_1=datos.getDoubleExtra("depth1", 0);
                profile.setDepth_1(String.valueOf(this.depth_1));
				this.depth_2=datos.getDoubleExtra("depth2", 0);
                profile.setDepth_2(String.valueOf(this.depth_2));
				this.depth_3=datos.getDoubleExtra("depth3", 0);
                profile.setDepth_3(String.valueOf(this.depth_3));
				this.depth_4=datos.getDoubleExtra("depth4", 0);
                profile.setDepth_4(String.valueOf(this.depth_4));
				this.depth_5=datos.getDoubleExtra("depth5", 0);
                profile.setDepth_5(String.valueOf(this.depth_5));
				this.depth_6=datos.getDoubleExtra("depth6", 0);
                profile.setDepth_6(String.valueOf(this.depth_6));
				
				cbRecordar.setChecked(true);
				cbRecordar.setEnabled(false);
				this.numberofsensor=6;
                profile.setNumberofsensor(this.numberofsensor);

			}
		}
		

		
	}

	/**
	* Creamos el método onSaveInstance para recuperar posteriormente los datos, al volver de la entrada de la profundidad de los sensores 
	*/
	protected void onSaveInstanceState(Bundle estado){
		
		super.onSaveInstanceState(estado);
		estado.putString("markerrecupered", profile.getMarkername());
		estado.putString("kduinonamerecupered", profile.getKduinoname());

	}

	/**
	*  Recuperamos los datos al volver de los menus depth y los mostramos en los editText correspondientes
	*/
	protected void onRestoreInstanceState(Bundle estado){  
		
		super.onRestoreInstanceState(estado);
	
		
		Editname.setText(estado.getString("markerrecupered"));
		Editnameofkaduino.setText(estado.getString("kduinonamerecupered"));

	}

	
}
